var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { CommonModule } from '@angular/common';
import { Injectable, NgModule, Optional, SkipSelf } from '@angular/core';
import 'rxjs/add/operator/toPromise';
import { HttpClient, HttpHeaders } from '@angular/common/http';
var XmlUtilities = (function () {
    function XmlUtilities() {
    }
    /**
     * @param {?} stringToEscape
     * @return {?}
     */
    XmlUtilities.escapeString = function (stringToEscape) {
        if (stringToEscape)
            return (stringToEscape + "")
                .replace(/&(?!(amp;)|(lt;)|(gt;)|(quot;)|(#39;)|(apos;))/g, "&amp;")
                .replace(/</g, '&lt;')
                .replace(/>/g, '&gt;')
                .replace(/"/g, '&quot;')
                .replace(/'/g, '&apos;');
        return stringToEscape;
    };
    return XmlUtilities;
}());
//new http client 
var SharepointListsWebService = (function () {
    /**
     * @param {?} http
     */
    function SharepointListsWebService(http$$1) {
        this.http = http$$1;
        this.serviceUrl = '_vti_bin/Lists.asmx';
        this.xmlPayloadWrapperStart = "<?xml version=\"1.0\" encoding=\"utf-8\"?>\n<soap12:Envelope xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\" xmlns:soap12=\"http://www.w3.org/2003/05/soap-envelope\">\n  <soap12:Body>";
        this.xmlPayloadWrapperEnd = '</soap12:Body></soap12:Envelope>';
        this.getListItemsPayload = "\n    <GetListItems xmlns=\"http://schemas.microsoft.com/sharepoint/soap/\">\n      <listName>listNamePayLoad</listName>\n      <viewName>viewNamePayLoad</viewName>\n      <query>queryPayload</query>\n      <viewFields>viewFieldsPayload</viewFields>\n      <rowLimit>rowLimitPayload</rowLimit>\n      <QueryOptions>queryOptionsPayload</QueryOptions>\n    </GetListItems>";
        this.updateListItemsPayload = "<UpdateListItems xmlns=\"http://schemas.microsoft.com/sharepoint/soap/\"><listName>listNamePayLoad</listName><updates>updatesPayLoad</updates></UpdateListItems>";
        this.headers = new HttpHeaders().set('Content-Type', 'application/soap+xml; charset=utf-8');
    }
    /**
     * @param {?} ctor
     * @param {?} filterQuery
     * @param {?} camlQuery
     * @param {?} orderByField
     * @return {?}
     */
    SharepointListsWebService.prototype.getListItems = function (ctor, filterQuery, camlQuery, orderByField) {
        var /** @type {?} */ dummyInstance = new ctor();
        var /** @type {?} */ currentPayload = this.xmlPayloadWrapperStart + this.getListItemsPayload + this.xmlPayloadWrapperEnd;
        currentPayload = currentPayload.replace("listNamePayLoad", XmlUtilities.escapeString(dummyInstance.getListName()));
        currentPayload = currentPayload.replace("viewNamePayLoad", "");
        if (filterQuery || camlQuery) {
            if (filterQuery) {
                var /** @type {?} */ internalCamlQuery = "<Query><Where><Eq><FieldRef Name='FieldName' /><Value Type='Text'>ValueName</Value></Eq></Where></Query>";
                internalCamlQuery = internalCamlQuery.replace("FieldName", filterQuery[0]);
                internalCamlQuery = internalCamlQuery.replace("ValueName", XmlUtilities.escapeString(filterQuery[1]));
                currentPayload = currentPayload.replace("queryPayload", internalCamlQuery);
            }
            else {
                currentPayload = currentPayload.replace("queryPayload", camlQuery);
            }
        }
        else {
            currentPayload = currentPayload.replace("queryPayload", "");
        }
        currentPayload = currentPayload.replace("viewFieldsPayload", "");
        currentPayload = currentPayload.replace("rowLimitPayload", "");
        currentPayload = currentPayload.replace("queryOptionsPayload", "");
        return this.http.post(dummyInstance.getSiteUrl() + this.serviceUrl, currentPayload, { headers: this.headers, responseType: 'text' })
            .toPromise()
            .then(function (res) {
            var /** @type {?} */ filledResponse = [];
            $(res).find("z\\:row, row").each(function (index) {
                filledResponse.push(new ctor($(this)[0].attributes));
            });
            return filledResponse;
        })
            .catch(this.handleError);
    };
    /**
     * @param {?} itemToUpdate
     * @param {?} newValue
     * @return {?}
     */
    SharepointListsWebService.prototype.updateListItem = function (itemToUpdate, newValue) {
        var /** @type {?} */ currentPayload = this.xmlPayloadWrapperStart + this.updateListItemsPayload + this.xmlPayloadWrapperEnd;
        currentPayload = currentPayload.replace("listNamePayLoad", XmlUtilities.escapeString(itemToUpdate.getListName()));
        currentPayload = currentPayload.replace("updatesPayLoad", "<Batch OnError=\"Continue\"><Method ID=\"1\" Cmd=\"Update\"><Field Name=\"ID\">" + itemToUpdate.ID + "</Field><Field Name=\"" + itemToUpdate.getFieldToUpdate() + "\">" + XmlUtilities.escapeString(newValue) + "</Field></Method></Batch>");
        return this.http.post(itemToUpdate.getSiteUrl() + this.serviceUrl, currentPayload, { headers: this.headers, responseType: 'text' })
            .toPromise()
            .then(function () { return null; })
            .catch(this.handleError);
    };
    /**
     * @param {?} error
     * @return {?}
     */
    SharepointListsWebService.prototype.handleError = function (error) {
        console.error('An error occurred', error); // for demo purposes only
        return Promise.reject(error.message || error);
    };
    /**
     * @param {?} itemToUpdate
     * @param {?} keyValuePairs
     * @return {?}
     */
    SharepointListsWebService.prototype.addOrUpdateListItem = function (itemToUpdate, keyValuePairs) {
        var /** @type {?} */ currentPayload = this.xmlPayloadWrapperStart + this.updateListItemsPayload + this.xmlPayloadWrapperEnd;
        var /** @type {?} */ perColumnString = "<Field Name=\"fieldName\">fieldValue</Field>";
        var /** @type {?} */ allColumnsToUpdate = '';
        var /** @type {?} */ command = "New";
        //if there is an existing 'ID' property with a value, then this is not new but update.
        for (var /** @type {?} */ i = 0; i < keyValuePairs.length; i++) {
            if (keyValuePairs[i][0] == "ID" && keyValuePairs[i][1]) {
                command = "Update";
                break;
            }
        }
        keyValuePairs.forEach(function (entry) { return allColumnsToUpdate = allColumnsToUpdate + perColumnString.replace("fieldName", entry[0]).replace("fieldValue", XmlUtilities.escapeString(entry[1])); });
        currentPayload = currentPayload.replace("listNamePayLoad", XmlUtilities.escapeString(itemToUpdate.getListName()));
        currentPayload = currentPayload.replace("updatesPayLoad", "<Batch OnError=\"Continue\"><Method ID=\"1\" Cmd=\"" + command + "\">" + allColumnsToUpdate + "</Method></Batch>");
        return this.http.post(itemToUpdate.getSiteUrl() + this.serviceUrl, currentPayload, { headers: this.headers, responseType: 'text' })
            .toPromise()
            .then(function (res) {
            return +$(res).find("z\\:row:first, row:first").attr("ows_ID");
        })
            .catch(this.handleError);
    };
    /**
     * @param {?} itemsToRemove
     * @return {?}
     */
    SharepointListsWebService.prototype.removeListItems = function (itemsToRemove) {
        var /** @type {?} */ currentPayload = this.xmlPayloadWrapperStart + this.updateListItemsPayload + this.xmlPayloadWrapperEnd;
        currentPayload = currentPayload.replace("listNamePayLoad", XmlUtilities.escapeString(itemsToRemove[0].getListName()));
        var /** @type {?} */ updatesPayload = '<Batch OnError="Continue">';
        for (var /** @type {?} */ methodId = 1; methodId <= itemsToRemove.length; methodId++) {
            updatesPayload += '<Method ID="' + methodId + '" Cmd="Delete"><Field Name="ID">' + itemsToRemove[methodId - 1].ID + '</Field></Method>';
        }
        updatesPayload += "</Batch>";
        currentPayload = currentPayload.replace("updatesPayLoad", updatesPayload);
        return this.http.post(itemsToRemove[0].getSiteUrl() + this.serviceUrl, currentPayload, { headers: this.headers, responseType: 'text' })
            .toPromise().then(function (res) {
            var /** @type {?} */ errorList = [];
            $(res).find("result:not(:contains('0x00000000'))").each(function (index) {
                errorList.push($(this).find('ErrorCode').text());
            });
            return Promise.resolve(errorList);
        })
            .catch(this.handleError);
    };
    /**
     * @param {?} itemsToAddOrUpdate
     * @return {?}
     */
    SharepointListsWebService.prototype.addOrUpdateListItems = function (itemsToAddOrUpdate) {
        var /** @type {?} */ currentPayload = this.xmlPayloadWrapperStart + this.updateListItemsPayload + this.xmlPayloadWrapperEnd;
        currentPayload = currentPayload.replace("listNamePayLoad", XmlUtilities.escapeString(itemsToAddOrUpdate[0].getListName()));
        var /** @type {?} */ updatesPayload = '<Batch OnError="Continue">';
        var /** @type {?} */ idFieldXml;
        for (var /** @type {?} */ i = 0; i < itemsToAddOrUpdate.length; i++) {
            idFieldXml = "";
            if (itemsToAddOrUpdate[i].ID && itemsToAddOrUpdate[i].ID > 0)
                idFieldXml = '<Field Name="ID">' + itemsToAddOrUpdate[i].ID + '</Field>';
            updatesPayload += '<Method ID="' + (i + 1) + '" Cmd="' + (idFieldXml ? "Update" : "New") + '">';
            if (idFieldXml)
                updatesPayload += idFieldXml;
            for (var _i = 0, _a = itemsToAddOrUpdate[i].getItemProperties(); _i < _a.length; _i++) {
                var property = _a[_i];
                if (property != "ID") {
                    updatesPayload += '<Field Name="' + property + '">' + XmlUtilities.escapeString(itemsToAddOrUpdate[i][property]) + '</Field>';
                }
            }
            updatesPayload += "</Method>";
        }
        updatesPayload += "</Batch>";
        currentPayload = currentPayload.replace("updatesPayLoad", updatesPayload);
        return this.http.post(itemsToAddOrUpdate[0].getSiteUrl() + this.serviceUrl, currentPayload, { headers: this.headers, responseType: 'text' })
            .toPromise().then(function (res) {
            var /** @type {?} */ finalResult = [];
            var /** @type {?} */ counter = 0;
            var /** @type {?} */ currentItem;
            $(res).find("Result").each(function (index) {
                // first, check for errors...
                currentItem = itemsToAddOrUpdate[counter];
                if ($(this).find('ErrorCode').text() != '0x00000000') {
                    finalResult.push([currentItem, $(this).find('ErrorCode').text()]);
                }
                else {
                    if ((!currentItem.ID) || currentItem.ID == 0) {
                        currentItem.ID = +$(this).find("z\\:row, row").attr("ows_ID");
                    }
                    finalResult.push([currentItem, ""]);
                }
                counter++;
            });
            return finalResult;
        }).catch(this.handleError);
    };
    return SharepointListsWebService;
}());
SharepointListsWebService.decorators = [
    { type: Injectable },
];
/**
 * @nocollapse
 */
SharepointListsWebService.ctorParameters = function () { return [
    { type: HttpClient, },
]; };
/**
 * Dummy version of an authenticated user service
 */
var UrlService = (function () {
    function UrlService() {
    }
    /**
     * @return {?}
     */
    UrlService.prototype.navigateToDefaultSource = function () {
        if (GetUrlKeyValue('Source', false, window.location.href)) {
            window.location.href = GetUrlKeyValue('Source', false, window.location.href);
        }
        else {
            window.location.href = _spPageContextInfo.webServerRelativeUrl;
        }
    };
    /**
     * @return {?}
     */
    UrlService.prototype.getItemId = function () {
        try {
            return GetUrlKeyValue('ID', false, window.location.href);
        }
        catch (x) {
            return '';
        }
    };
    /**
     * @return {?}
     */
    UrlService.prototype.getCurrentSiteUrl = function () {
        return _spPageContextInfo.webServerRelativeUrl + "/";
    };
    return UrlService;
}());
UrlService.decorators = [
    { type: Injectable },
];
/**
 * @nocollapse
 */
UrlService.ctorParameters = function () { return []; };
var SharePointUserProfile = (function () {
    function SharePointUserProfile() {
    }
    return SharePointUserProfile;
}());
var SharePointUserProfileWebService = (function () {
    /**
     * @param {?} http
     */
    function SharePointUserProfileWebService(http$$1) {
        this.http = http$$1;
        this.serviceUrl = '/_vti_bin/UserProfileService.asmx';
        this.xmlPayloadWrapperStart = "<?xml version=\"1.0\" encoding=\"utf-8\"?>\n<soap12:Envelope xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\" xmlns:soap12=\"http://www.w3.org/2003/05/soap-envelope\">\n  <soap12:Body>";
        this.xmlPayloadWrapperEnd = '</soap12:Body></soap12:Envelope>';
        this.getUserProfileByNamePayload = "\n    <GetUserProfileByName xmlns=\"http://microsoft.com/webservices/SharePointPortalServer/UserProfileService\">\n      <AccountName>accountNameString</AccountName>\n    </GetUserProfileByName>";
        this.headers = new HttpHeaders().set('Content-Type', 'application/soap+xml; charset=utf-8');
    }
    /**
     * @param {?=} accountName
     * @return {?}
     */
    SharePointUserProfileWebService.prototype.getUserProfileByName = function (accountName) {
        var /** @type {?} */ currentPayload = this.xmlPayloadWrapperStart + this.getUserProfileByNamePayload + this.xmlPayloadWrapperEnd;
        if (accountName) {
            currentPayload = currentPayload.replace("accountNameString", accountName);
        }
        else {
            currentPayload = currentPayload.replace("accountNameString", "");
        }
        return this.http.post(this.serviceUrl, currentPayload, { headers: this.headers, responseType: 'text' })
            .toPromise()
            .then(function (res) {
            var /** @type {?} */ filledResponse = new SharePointUserProfile();
            var /** @type {?} */ jQueryValue = $(res).find("PropertyData:has(name:contains('WorkEmail'))").find('value').text();
            if (jQueryValue) {
                filledResponse.workEmail = jQueryValue;
            }
            jQueryValue = $(res).find("PropertyData:has(name:contains('WorkPhone'))").find('value').text();
            if (jQueryValue) {
                filledResponse.workPhone = jQueryValue;
            }
            $(res).find("z\\:row, row").each(function (index) {
                //$(this)[0].attributes)
                //do some fancy jquery coding here.
            });
            return filledResponse;
        })
            .catch(this.handleError);
    };
    /**
     * @param {?} error
     * @return {?}
     */
    SharePointUserProfileWebService.prototype.handleError = function (error) {
        console.error('An error occurred', error); // for demo purposes only
        return Promise.reject(error.message || error);
    };
    return SharePointUserProfileWebService;
}());
/* return this.http.post(dummyInstance.getSiteUrl()+this.serviceUrl, currentPayload,{headers:this.headers,})
.toPromise()
.then(function(res)
    {
        let filledResponse:SharepointListItem[] = [];
        $(res.text()).find("z\\:row, row").each(function( index:any ) {
            filledResponse.push(new ctor($(this)[0].attributes));
        });
        return filledResponse;
})
.catch(this.handleError);
}



.then(function (res){
    return +$(res.text()).find("z\\:row:first, row:first").attr("ows_ID");
})
.catch(this.handleError);
} */
SharePointUserProfileWebService.decorators = [
    { type: Injectable },
];
/**
 * @nocollapse
 */
SharePointUserProfileWebService.ctorParameters = function () { return [
    { type: HttpClient, },
]; };
var SharepointUserGroupWebService = (function () {
    /**
     * @param {?} http
     */
    function SharepointUserGroupWebService(http$$1) {
        this.http = http$$1;
        this.serviceUrl = '_vti_bin/UserGroup.asmx';
        this.xmlPayloadWrapperStart = "<?xml version=\"1.0\" encoding=\"utf-8\"?>\n<soap12:Envelope xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\" xmlns:soap12=\"http://www.w3.org/2003/05/soap-envelope\">\n  <soap12:Body>";
        this.xmlPayloadWrapperEnd = '</soap12:Body></soap12:Envelope>';
        this.headers = new HttpHeaders().set('Content-Type', 'application/soap+xml; charset=utf-8');
        this.getUserLoginFromEmailPayload = "<GetUserLoginFromEmail xmlns=\"http://schemas.microsoft.com/sharepoint/soap/directory/\"><emailXml><Users>payload</Users></emailXml></GetUserLoginFromEmail>";
        this.addUserCollectionToGroupPayload = "<AddUserCollectionToGroup xmlns=\"http://schemas.microsoft.com/sharepoint/soap/directory/\">\n      <groupName>groupNamePayload</groupName>\n      <usersInfoXml><Users>usersPayload</Users></usersInfoXml>\n    </AddUserCollectionToGroup>";
        this.removeUserCollectionFromGroupPayload = "<RemoveUserCollectionFromGroup xmlns=\"http://schemas.microsoft.com/sharepoint/soap/directory/\">\n      <groupName>groupNamePayload</groupName>\n      <userLoginNamesXml><Users>usersPayload</Users></userLoginNamesXml>\n    </RemoveUserCollectionFromGroup>";
        this.getUserCollectionFromGroupPayload = "<GetUserCollectionFromGroup xmlns=\"http://schemas.microsoft.com/sharepoint/soap/directory/\">\n      <groupName>groupNamePayload</groupName></GetUserCollectionFromGroup>";
    }
    /**
     * @param {?} emailStrings
     * @param {?} siteurl
     * @return {?}
     */
    SharepointUserGroupWebService.prototype.getUserLoginFromEmail = function (emailStrings, siteurl) {
        var /** @type {?} */ requestBody = this.xmlPayloadWrapperStart + this.getUserLoginFromEmailPayload + this.xmlPayloadWrapperEnd;
        var /** @type {?} */ userString = "<User Email=\"emailString\"/>";
        var /** @type {?} */ finalPayload = "";
        for (var /** @type {?} */ x = 0; x < emailStrings.length; x++) {
            finalPayload += userString.replace("emailString", emailStrings[x]);
        }
        requestBody = requestBody.replace("payload", finalPayload);
        return this.http.post(siteurl + this.serviceUrl, requestBody, { headers: this.headers, responseType: 'text' })
            .toPromise()
            .then(function (res) {
            var /** @type {?} */ result = [];
            $(res).find("User").each(function (index) {
                result.push({ id: $(this).attr('SiteUser'), displayName: $(this).attr('DisplayName'), login: $(this).attr('Login'), email: $(this).attr('Email') });
            });
            return result;
        })
            .catch(this.handleError);
    };
    /**
     * @param {?} users
     * @param {?} groupName
     * @param {?} siteurl
     * @return {?}
     */
    SharepointUserGroupWebService.prototype.addUserCollectionToGroup = function (users, groupName, siteurl) {
        var /** @type {?} */ requestBody = this.xmlPayloadWrapperStart + this.addUserCollectionToGroupPayload + this.xmlPayloadWrapperEnd;
        requestBody = requestBody.replace("groupNamePayload", groupName);
        var /** @type {?} */ internalpayload = "";
        for (var /** @type {?} */ x = 0; x < users.length; x++) {
            /*internalpayload+="<User LoginName=\""+users[x].login+"\" Email=\""
            +users[x].email+"\" Name=\""+ users[x].displayName +"\"/>";*/
            internalpayload += "<User LoginName=\"" + users[x].login + "\"/>";
        }
        requestBody = requestBody.replace("usersPayload", internalpayload);
        return this.http.post(siteurl + this.serviceUrl, requestBody, { headers: this.headers, responseType: 'text' })
            .toPromise()
            .then(function (res) {
            return 0;
        })
            .catch(this.handleError);
    };
    /**
     * @param {?} users
     * @param {?} groupName
     * @param {?} siteurl
     * @return {?}
     */
    SharepointUserGroupWebService.prototype.removeUserCollectionFromGroup = function (users, groupName, siteurl) {
        var /** @type {?} */ requestBody = this.xmlPayloadWrapperStart + this.removeUserCollectionFromGroupPayload + this.xmlPayloadWrapperEnd;
        requestBody = requestBody.replace("groupNamePayload", groupName);
        var /** @type {?} */ internalpayload = "";
        for (var /** @type {?} */ x = 0; x < users.length; x++) {
            internalpayload += "<User LoginName=\"" + users[x].login + "\"/>";
        }
        requestBody = requestBody.replace("usersPayload", internalpayload);
        return this.http.post(siteurl + this.serviceUrl, requestBody, { headers: this.headers, responseType: 'text' })
            .toPromise()
            .then(function (res) {
            return 0;
        })
            .catch(this.handleError);
    };
    /**
     * @param {?} groupName
     * @param {?} siteUrl
     * @return {?}
     */
    SharepointUserGroupWebService.prototype.getUserCollectionFromGroup = function (groupName, siteUrl) {
        var /** @type {?} */ requestBody = this.xmlPayloadWrapperStart + this.getUserCollectionFromGroupPayload + this.xmlPayloadWrapperEnd;
        requestBody = requestBody.replace("groupNamePayload", groupName);
        return this.http.post(siteUrl + this.serviceUrl, requestBody, { headers: this.headers, responseType: 'text' })
            .toPromise()
            .then(function (res) {
            var /** @type {?} */ result = [];
            $(res).find("User").each(function (index) {
                result.push({ id: $(this).attr('ID'), displayName: $(this).attr('Name'), login: $(this).attr('LoginName'), email: $(this).attr('Email') });
            });
            return result;
        })
            .catch(this.handleError);
    };
    /**
     * @param {?} error
     * @return {?}
     */
    SharepointUserGroupWebService.prototype.handleError = function (error) {
        console.error('An error occurred', error); // for demo purposes only
        return Promise.reject(error.message || error);
    };
    return SharepointUserGroupWebService;
}());
SharepointUserGroupWebService.decorators = [
    { type: Injectable },
];
/**
 * @nocollapse
 */
SharepointUserGroupWebService.ctorParameters = function () { return [
    { type: HttpClient, },
]; };
var NgTaxServices = (function () {
    /**
     * @param {?} parentModule
     */
    function NgTaxServices(parentModule) {
        if (parentModule) {
            throw new Error('NgTaxServices / NgTaxSharePointWebServicesModule is already loaded. Import it in the AppModule only');
        }
    }
    /**
     * @return {?}
     */
    NgTaxServices.forRoot = function () {
        return {
            ngModule: NgTaxServices,
            providers: [SharepointListsWebService, UrlService, SharePointUserProfileWebService, SharepointUserGroupWebService]
        };
    };
    return NgTaxServices;
}());
NgTaxServices.decorators = [
    { type: NgModule, args: [{
                imports: [CommonModule],
                declarations: [],
                exports: []
            },] },
];
/**
 * @nocollapse
 */
NgTaxServices.ctorParameters = function () { return [
    { type: NgTaxServices, decorators: [{ type: Optional }, { type: SkipSelf },] },
]; };
/**
 * @abstract
 */
var SharepointListItem = (function () {
    /**
     * @param {?=} rawResponse
     */
    function SharepointListItem(rawResponse) {
        if (rawResponse) {
            this.ID = +this.findString('ows_id', rawResponse);
            for (var x = 0; x < this.getItemProperties().length; x++) {
                this[this.getItemProperties()[x]] = this.findString('ows_' + this.getItemProperties()[x].toLowerCase(), rawResponse);
            }
        }
    }
    /**
     * @param {?} searchTerm
     * @param {?} myArray
     * @return {?}
     */
    SharepointListItem.prototype.findString = function (searchTerm, myArray) {
        for (var /** @type {?} */ x = 0; x < myArray.length; x++) {
            if (myArray[x].name == searchTerm) {
                return myArray[x].value;
            }
        }
        return '';
    };
    /**
     * @abstract
     * @return {?}
     */
    SharepointListItem.prototype.getSiteUrl = function () { };
    /**
     * @abstract
     * @return {?}
     */
    SharepointListItem.prototype.getListName = function () { };
    /**
     * @abstract
     * @return {?}
     */
    SharepointListItem.prototype.getFieldToUpdate = function () { };
    /**
     * @return {?}
     */
    SharepointListItem.prototype.getItemProperties = function () {
        return [];
    };
    /**
     * @param {?} aString
     * @return {?}
     */
    SharepointListItem.prototype.toBoolean = function (aString) {
        if (this[aString]) {
            this[aString] = this[aString] && this[aString] == "true";
        }
    };
    /**
     * @param {?} aString
     * @return {?}
     */
    SharepointListItem.prototype.toInteger = function (aString) {
        if (this[aString] && this[aString].includes(".")) {
            this[aString] = this[aString].split(".")[0];
        }
    };
    /**
     * @param {?} id
     * @param {?} keyValuePairs
     * @return {?}
     */
    SharepointListItem.buildRawResponseArray = function (id, keyValuePairs) {
        var /** @type {?} */ response = [];
        response.push({ name: "ows_id", value: id });
        for (var _i = 0, keyValuePairs_1 = keyValuePairs; _i < keyValuePairs_1.length; _i++) {
            var keyValuePair = keyValuePairs_1[_i];
            response.push({ name: "ows_" + keyValuePair[0].toLowerCase(), value: keyValuePair[1] });
        }
        return response;
    };
    return SharepointListItem;
}());
var UserInfoListEntry = (function (_super) {
    __extends(UserInfoListEntry, _super);
    /**
     * @param {?=} rawResponse
     */
    function UserInfoListEntry(rawResponse) {
        return _super.call(this, rawResponse) || this;
    }
    /**
     * @return {?}
     */
    UserInfoListEntry.prototype.getItemProperties = function () {
        return ["title", "jobTitle", "name", "email"];
    };
    /**
     * @return {?}
     */
    UserInfoListEntry.prototype.getSiteUrl = function () {
        return '/';
    };
    /**
     * @return {?}
     */
    UserInfoListEntry.prototype.getListName = function () {
        return 'UserInfo';
    };
    /**
     * @return {?}
     */
    UserInfoListEntry.prototype.getFieldToUpdate = function () {
        return 'Not implemented';
    };
    return UserInfoListEntry;
}(SharepointListItem));
var TaxSpUser = (function () {
    function TaxSpUser() {
    }
    return TaxSpUser;
}());
/**
 * Generated bundle index. Do not edit.
 */
export { NgTaxServices, SharepointListsWebService, UrlService, SharePointUserProfileWebService, SharepointUserGroupWebService, SharepointListItem, SharePointUserProfile, UserInfoListEntry, TaxSpUser, XmlUtilities };
//# sourceMappingURL=ng-tax-share-point-web-services-module.es5.js.map
